---
title: Document.ononline
slug: Web/API/Document/ononline
tags:
  - API
  - DOM
  - Document
  - Property
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>Document.online</code></strong> event is fired on the {{HtmlElement("body")}} of each page when the browser switches between online and offline mode. Additionally, the events bubble up from <code>document.body</code>, to <code>document</code>, ending at <code>window</code>. Both events are non-cancellable (you can't prevent the user from coming online, or going offline).</p>

<p><code>window.navigator.onLine</code> returns boolean <code>true</code> if the browser is online and <code>false</code> if it is definitely offline (disconnected from the network). The <code>online</code> and <code>offline</code> events are fired when the value of this attribute changes.</p>

<div class="note">
<p>It is important to note that this event and attribute are inherently unreliable. A computer can be connected to a network without having Internet access.</p>
</div>

<p>You can register listeners for these events in a few familiar ways:</p>

<ul>
 <li>Using {{domxref("EventTarget.addEventListener", "addEventListener")}} on the <code>window</code>, <code>document</code>, or <code>document.body</code></li>
 <li>By setting the <code>.ononline</code> or <code>.onoffline</code> properties on <code>document</code> or <code>document.body</code> to a JavaScript <code>Function</code> object. (<strong>Note:</strong> using <code>window.ononline</code> or <code>window.onoffline</code> will not work for compatibility reasons.)</li>
 <li>By specifying <code>ononline="..."</code> or <code>onoffline="..."</code> attributes on the <code>&lt;body&gt;</code> tag in the HTML markup.</li>
</ul>

<h2 id="Example">Example</h2>

<p>There's <a class="external link-https external-icon" href="https://bugzilla.mozilla.org/attachment.cgi?id=220609">a simple test case</a> that you can run to verify that the events are working.</p>

<h2 id="References">References</h2>

<ul>
 <li><a href="/en-US/docs/Online_and_offline_events">Online and offline events [en-US]</a></li>
 <li><a href="http://www.whatwg.org/specs/web-apps/current-work/#event-online">WHATWG Web App Specification</a></li>
</ul>
